SystemOrganization addCategory: #'GT-GlamourDebugger'!

GTDebugger subclass: #GTGlamourDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 16:37'!
defaultTitle

	^ 'Glamour Debugger'! !

!GTGlamourDebugger class methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:36'!
handlesContext: aContext

	^ aContext locateBrowserContext notNil ! !

!GTGlamourDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:39'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 50.! !

!GTGlamourDebugger class methodsFor: 'private' stamp: 'AndreiChis 8/8/2013 16:45'!
sessionClass

	^ GTGlamourDebugSession! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:25'!
browserStructureFor: aGlmBrowser in: aComposite
	
	aComposite roassal 
		title: 'Browser structure';
		painting: [:view :b | 
			aGlmBrowser viewTreeOn: view ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 8/8/2013 16:43'!
browserTransmissionsIn: browser
	
	browser transmit
		from: #stack port: #context;
		to: #browser;
		andShow: [ :composite | self browserStructureFor: self session rootBrowser in: composite ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/24/2013 20:53'!
debuggerStructureIn: browser

	browser
			row: [ :row | 
						row
							column: [ :c |
								c
									row: #stack;
									row: #code ];
							column: #browser ] span: 4;
			row: #inspector span: 3.! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:25'!
debuggerTransmissionsIn: browser.
		
	super debuggerTransmissionsIn: browser.
	self browserTransmissionsIn: browser.! !

!GTGlamourDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:17'!
debuggingActionsPragmas

	^ super debuggingActionsPragmas, { #glamourDebuggingAction }! !

DebugSession subclass: #GTGlamourDebugSession
	instanceVariableNames: 'rootBrowserContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/8/2013 16:41'!
createPredicateForBlock: aBlock 

	^ NewBlockContextPredicate for: aBlock! !

!GTGlamourDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/8/2013 16:41'!
createStepPredicateForBlock: aBlock 

	^ self createStepPredicatForPredicate: (self createPredicatForBlock: aBlock)
			! !

!GTGlamourDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/8/2013 16:42'!
createStepPredicateForPredicate: aPredicate 

	^ (self createPredicateForBlock: [ self isActive not ]) or: aPredicate
	! !

!GTGlamourDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:42'!
isActive

	^ rootBrowserContext  
		ifNil: [ false ] 
		ifNotNil: [ 
			rootBrowserContext isDead not and: [
				
				rootBrowserContext ~= self process suspendedContext or: [rootBrowserContext willReturn not ]
				
				 ]  ]! !

!GTGlamourDebugSession methodsFor: 'debugging actions' stamp: 'AndreiChis 8/8/2013 18:28'!
newStepUntil: aPredicate from: aContext 

	^ super 
		newStepUntil: (self createStepPredicateForPredicate: aPredicate) 
		from: aContext ! !

!GTGlamourDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 8/8/2013 16:46'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	self flag: 'Have a method that is only called when the session is created and put this there'.
	rootBrowserContext ifNil:  [
		rootBrowserContext := aContext locateBrowserContext ]! !

!GTGlamourDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 16:41'!
rootBrowser

	^ rootBrowserContext receiver! !

!GTGlamourDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 16:41'!
rootBrowserContext

	^ rootBrowserContext! !

!GLMCompositePresentation methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 8/8/2013 15:40'!
umlClassWithTitle: umlName view: view nodes: aNodes forEach: aOneArgForEachBlock

	self 
		umlClassWithTitle: umlName 
		view: view 
		nodes: aNodes 
		forEachInstanceVariable: [:e | e]
		methods: aOneArgForEachBlock! !

!GLMCompositePresentation methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 8/8/2013 15:41'!
umlClassWithTitle: umlName view: view nodes: aNodes 
forEachInstanceVariable: aOneArgForEachBlock1 methods: aOneArgForEachBlock2

	view shape rectangle color: Color white.
	view extensibleSizeWithPaddingGap: 0. 
	view nodes: aNodes forEach: [ :eachNode |
		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view interaction popupText.
		view shape centeredLabel text: umlName.
		view node: eachNode.

		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view shape rectangle.
		view nodes: (Array with: eachNode) forEach: aOneArgForEachBlock1.

		view interaction 
				nodraggable;
				forward: ROAbstractMouseDragging;
				forward: ROMouseClick.
		view shape rectangle color: Color white.
		view nodes: (Array with: eachNode) forEach: aOneArgForEachBlock2.
		
		view verticalLineLayout
				gapSize: 0;
				on: ROLayoutBegin
				do: [ :event | | maxWidth |
						maxWidth := event elements maxValue: #width. 
						event elements do: [ :eachElement | 
								eachElement width: maxWidth ] ];
				on: ROLayoutEnd
				do: [ :event | | strategy |
						strategy := ROFixedSizedParent new paddingGap: 0.
						event elements do: [ :eachElement |
								eachElement resizeStrategy: strategy ] ]
	].! !

!GLMCompositePresentation methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 8/8/2013 13:58'!
viewTreeOn: view
	| edges1 edges2 edges3 edges4 |
	
	self umlClassWithTitle: #name view: view nodes: self pane withAllPanes forEach: [ :each |
		view interaction
				nodraggable;
				forward: ROAbstractMouseDragging.
		view shape label text: #name.
		view nodes: each ports.
		view verticalLineLayout gapSize: 2 ].

	view shape label text: [:p | (p class name removePrefix: 'GLM') removeSuffix: 'Presentation' ].
	view nodes: self pane withAllPresentations.

	view shape orthoVerticalLine color: Color lightGray. 	
	edges1 := view edges: self pane withAllPanes from: #yourself to: [:each | each presentations ].

	view shape orthoVerticalLine color: Color lightGray. 
	edges2 := view edges: self pane withAllPanes from: #browser to: #yourself.

	view shape orthoVerticalLine color: Color lightGray. 
	edges3 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMDynamicPresentation]) from: #yourself to: #cachedPresentation.

	view shape orthoVerticalLine color: Color lightGray.
	edges4 := view edges: (self pane withAllPresentations select: [:each | each isKindOf: GLMCompositePresentation]) from: #yourself toAll: #presentations.


	view treeLayout layered userDefinedEdges: (edges1, edges2, edges3, edges4).

	view shape line color: Color blue. 
	view 
		edges: ((self pane withAllPresentations select: [:each | each isKindOf: GLMBrowser]) flatCollect: [:each | each transmissions])
		fromAll: #origins
		to: #destination.
		view shape line color: Color blue
! !

!MethodContext methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 8/8/2013 16:34'!
locateBrowserContext

	^ (self findContextSuchThat:  [ :ctx | 
		(ctx receiver class inheritsFrom: GLMPresentation)  and: [ ctx selector = #startOn: ] ]) ! !

!GLMBrowser methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ true! !

DebugAction subclass: #GTGlamourStepToNextStoneAction
	instanceVariableNames: 'debugStoneType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStepToNextStoneAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/9/2013 14:29'!
gtActionType
	<gtGlamourDebuggingAction>
	<gtContextGlamourDebuggingAction>! !

!GTGlamourStepToNextStoneAction methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 17:04'!
appliesToContext: aContext

	^ aContext locateBrowserContext notNil! !

!GTGlamourStepToNextStoneAction methodsFor: 'predicates' stamp: 'AndreiChis 8/9/2013 17:23'!
debuggingStone

	^ self session createPredicateForBlock: [ :aContext |
			aContext isInitialnstruction and: [
				(aContext method pragmaAt: self debuggingStonePragma) notNil ] ]! !

!GTGlamourStepToNextStoneAction methodsFor: 'predicates' stamp: 'AndreiChis 8/9/2013 14:30'!
debuggingStonePragma

	^ #debugStone:label:! !

!GTGlamourStepToNextStoneAction methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 17:13'!
defaultLabel

	^ 'Next debug stone'! !

!GTGlamourStepToNextStoneAction methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:39'!
executeAction
	| debugingStone |
	
	"The first time start searching for a debuging stone from the context selected by the user."
	debugingStone := self stepToDebuggingStoneFrom: self currentContext.

	[ debugingStone notNil ]
		whileTrue: [ 
			(debugingStone reachedTarget and: [ 
				debugingStone isActive and: [ 
					debugingStone completeAction ] ]) 
						"After the first time use the interruptedContext (start the search from where it was left of).
						Here the interruptedContext it is the same as the suspended context of the process."
						ifFalse: [ debugingStone := self stepToDebuggingStoneFrom: self interruptedContext ]
						"If a debuging stone reached its destination stop the search."
						ifTrue: [ ^ self ] ]
	! !

!GTGlamourStepToNextStoneAction methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 16:48'!
stepToDebuggingStoneFrom: aContext

	"Make sure the execution advances, and does not check the same context."
	self session stepInto: aContext.

	self session 
		newStepUntil: self debuggingStone
		from: self interruptedContext.
		
	^ self session isActive 
		ifTrue: [ 
			GTGlamourDebuggingStone 
				"Here interruptedContext is the same as the suspended context of the process."
				forPragma: (self interruptedContext method pragmaAt: self debuggingStonePragma) 
				forSession: self session  ]
		ifFalse: [ nil ]! !

DebugAction subclass: #GTGlamourStepToPresentationBuildAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStepToPresentationBuildAction class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/9/2013 12:17'!
gtActionType
	"<gtContextGlamourDebuggingAction>"! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:35'!
appliesToContext: aContext

	^ aContext locateBrowserContext notNil! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'actions' stamp: 'AndreiChis 8/8/2013 18:29'!
executeAction
	| presentationCreation presentationCode |
	presentationCreation := self presentationCreationPredicate.
	presentationCode := self presentationCodePredicate.

	self session newStepUntil: presentationCreation from: self currentContext.
	self session newStepUntil: presentationCode from: self interruptedContext.
	self session isActive ifTrue: [ 
		self session stepInto ]
		
	! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'initialize-release' stamp: 'AndreiChis 6/27/2013 11:49'!
initialize

	self label: 'Next presentation build'.
	self icon: GLMUIThemeExtraIcons glamorousPlay.! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 8/8/2013 16:47'!
presentationCodePredicate
	
	^ self session createPredicateForBlock: [ :aContext |
			aContext selector = #glamourValueWithArgs: and: [ 
				aContext peekInstruction arguments size > 0 and: [ 
				 	#( #value #valueWithArguments:) includes: aContext peekInstruction argument ] ] ]
! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 8/8/2013 16:47'!
presentationCreationPredicate

	^ self session createPredicateForBlock: [ :aContext |
			aContext methodClass = GLMPresentStrategy and: [ 
				aContext selector = #presentations and: [ 
					aContext isInitialnstruction ] ] ]

! !

Object subclass: #GTDebuggingStone
	instanceVariableNames: 'pragma session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTDebuggingStone class methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/8/2013 18:48'!
forPragma: aPragma forSession: aSession

	^ self new forPragma: aPragma forSession: aSession! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:37'!
actionSelector

	^ ('stepTo', (pragma argumentAt: 1) capitalized) asSymbol! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:36'!
activeSelector

	^ ('is', (pragma argumentAt: 1) capitalized, 'Valid') asSymbol! !

!GTDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 14:43'!
completeAction

	^ self perform: self actionSelector withEnoughArguments: (Array with: self session context)! !

!GTDebuggingStone methodsFor: 'initialization' stamp: 'AndreiChis 8/8/2013 18:28'!
forPragma: aPragma forSession: aSession
	
	pragma := aPragma.
	session := aSession! !

!GTDebuggingStone methodsFor: 'testing' stamp: 'AndreiChis 8/9/2013 14:32'!
isActive

	^ (self class canUnderstand: self activeSelector) 	
		ifFalse: [ true ]
		ifTrue: [ self perform: self activeSelector ]! !

!GTDebuggingStone methodsFor: 'testing' stamp: 'AndreiChis 8/9/2013 14:48'!
reachedTarget

	^ (self class canUnderstand: self tagetSelector) 	
		ifFalse: [ true ]
		ifTrue: [ self perform: self tagetSelector ]! !

!GTDebuggingStone methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 18:28'!
session

	^ session! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:46'!
tagetSelector

	^ ('has', (pragma argumentAt: 1) capitalized, 'ReachedTarget') asSymbol! !

GTDebuggingStone subclass: #GTGlamourDebuggingStone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebuggingStone methodsFor: 'private' stamp: 'AndreiChis 8/9/2013 17:50'!
glamourValueDeliveryPredicate

	^ self session createPredicateForBlock: [ :aContext |
			aContext selector = #glamourValueWithArgs: and: [ 
				aContext peekInstruction arguments size > 0 and: [
				 	#( #value #valueWithArguments:) includes: aContext peekInstruction argument ] ] ]

! !

!GTGlamourDebuggingStone methodsFor: 'testing context' stamp: 'AndreiChis 8/9/2013 17:39'!
hasPresentationConditionReachedTarget

	^ true
	"^ self session context peekInstruction arguments size = 1 and: [
		self session context peekInstruction argument = #condition ]"! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isPresentationConditionValid

	^ (self session context receiver condition 
		ifNil: [ false ]
		ifNotNil: [ :aBlock |  aBlock printString ~= [true] printString ])! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isPresentationCreationValid

	^ self session context receiver presentationsFactory notNil
	! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isTransmissionConditionValid

	^ self session context receiver condition isBlock! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isTransmissionTransformationValid

	^ self session context receiver transformation notNil! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:50'!
stepToGlamourValueBlock

	self session newStepUntil: self glamourValueDeliveryPredicate from: self session context.
	self session isActive ifTrue: [ 
		self session stepInto ].
	^ true! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:59'!
stepToPresentationCondition
	| ctxt |

	ctxt := self session context.
	self session 
		newStepUntil: ((self session createPredicateForBlock: [ ctxt isDead ]) or:  self glamourValueDeliveryPredicate)
		from: self session context.
		
	ctxt isDead not ifTrue: [ 
		self session stepInto ].
	
	^ ctxt isDead not! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:59'!
stepToPresentationCreation
	
	^ self stepToGlamourValueBlock! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 18:00'!
stepToTransmissionCondition

	^ self stepToGlamourValueBlock! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 18:00'!
stepToTransmissionTransformation

	^ self stepToGlamourValueBlock! !

!Object methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 6/19/2013 17:34'!
isGlamourBrowser

	^ false! !
